// Header.h
/*
Copyright (C) 2003  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _HEADER_H
#define _HEADER_H

#ifdef _WIN32
#define STL_USING_LIST
#include <stlhelper.h>
#else
#include <list>
#endif


struct HEADER
{
//	struct headerstruct *next;
	char *name;
	char *value;
};
typedef std::list<HEADER *> header_v;

class Header {
public:
	Header();
	Header(char *,int);
	~Header();
	int getvalue(char *,char *,short); // (name, buffer, length)
	void replacevalue(char *,char *);
	int getlength(char *);

	/* get names */
	void getfirst(char *,short);
	void getnext(char *,short);
	int getindex() { return dataindex; }

private:
	Header(const Header& );
	Header& operator=(const Header& );
//	HEADER *headerbase;
	header_v m_headers;
//	HEADER *current;
	header_v::iterator m_current;
	int dataindex;
};

#endif // _HEADER_H
