// Ticks_i.h
/*
Copyright (C) 2003  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef _TICKS_I_H
#define _TICKS_I_H
#ifndef _WIN32

#include <sys/time.h>
#include <unistd.h>

class Ticks
{
public:
	void Start() {
		struct timeval tv;
		struct timezone tz;
		gettimeofday(&tv,&tz);
		d0 = tv.tv_sec;
		d0 *= 1000000;
		d0 += tv.tv_usec;
		dstop = d0;
		dtemp = d0;
	}
	Ticks() {
		Start();
	}
	~Ticks() {
	}
	void Stop() {
		struct timeval tv;
		struct timezone tz;
		gettimeofday(&tv,&tz);
		dstop = tv.tv_sec;
		dstop *= 1000000;
		dstop += tv.tv_usec;
	}
	double Time(void) {
		return dstop - d0;
	}
	void Time(char *s) {
		sprintf(s,"%.4f sec",Time() / 1000000);
	}
	void TempTime(char *s) {
		struct timeval tv;
		struct timezone tz;
		double dnow;
		gettimeofday(&tv,&tz);
		dnow = tv.tv_sec;
		dnow *= 1000000;
		dnow += tv.tv_usec;
		double d = dnow - dtemp;
		dtemp = dnow;
		sprintf(s,"%.4f sec",d / 1000000);
	}
private:
	double d0;
	double dstop;
	double dtemp;
};

#endif // _WIN32
#endif // _TICKS_I_H
